package com.qs.printer.activity;

import java.io.UnsupportedEncodingException;

import android.app.Activity;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.printertools.bt.R;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.qs.helper.printer.PrintService;
import com.qs.helper.printer.PrinterClass;

public class PrintBarCodeActivity extends Activity {
	private TextView et_input;
	private Button bt_bar;
	private ImageView image_eq;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_print_barcode);
		et_input=(EditText)findViewById(R.id.et_input);
		bt_bar = (Button) findViewById(R.id.bt_bar);
		image_eq=(ImageView) findViewById(R.id.image_eq);
		bt_bar.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				if (PrintService.pl.getState() != PrinterClass.STATE_CONNECTED) {
					Toast.makeText(
							PrintBarCodeActivity.this,
							PrintBarCodeActivity.this.getResources().getString(
									R.string.str_unconnected), Toast.LENGTH_SHORT).show();
					return;
				}

				String message = et_input.getText().toString();

				if (message.getBytes().length > message.length()) {
					Toast.makeText(
							PrintBarCodeActivity.this,
							PrintBarCodeActivity.this.getResources().getString(
									R.string.str_cannotcreatebar), Toast.LENGTH_SHORT).show();
					return;
				}

				if (message.length() > 0) {

					byte[] btdata=null;
					try {
						btdata=message.getBytes("ASCII");
					} catch (UnsupportedEncodingException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					//Enable the barcode
					PrintService.pl.write(new byte[]{0x1d,0x45,0x43,0x01});


					//Set the barcode height is 162
//					MainActivity.pl.write(new byte[]{0x1d,0x68,(byte) 0xa2});
					PrintService.pl.write(new byte[]{0x1d,0x68,(byte) 0x82});


					//Set HRI character print location on bottom
					PrintService.pl.write(new byte[]{0x1d,0x48,0x02});


					PrintService.pl.write(new byte[]{0x1d,0x77,0x02});

					//Print the barcode use code128

					byte[] qrHead=new byte[]{0x1d,0x6b,0x49,(byte) btdata.length};
//					byte[] qrHead=new byte[]{0x1d,0x6b,0x44,(byte) btdata.length};

					byte[] barCodeData=new byte[qrHead.length+btdata.length];
					System.arraycopy(qrHead, 0, barCodeData, 0, qrHead.length);
					System.arraycopy(btdata, 0, barCodeData, qrHead.length, btdata.length);
					//居中指令
					PrintService.pl.write(new byte[] { 0x1b, 0x61,0x01});
					PrintService.pl.write(barCodeData);
					PrintService.pl.write(new byte[] { 0x1d, 0x0c });
					//居左指令
					PrintService.pl.write(new byte[] { 0x1b, 0x61,0x00});
					try {
						image_eq.setImageBitmap(CreateOneDCode(message));
					} catch (WriterException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

				}

			}
		});
	}

	/**
	 * 用于将给定的内容生成成一维码 注：目前生成内容为中文的话将直接报错，要修改底层jar包的内容
	 *
	 * @param content 将要生成一维码的内容
	 * @return 返回生成好的一维码bitmap
	 * @throws WriterException WriterException异常
	 */
	public Bitmap CreateOneDCode(String content) throws WriterException {
		//
		BitMatrix matrix = new MultiFormatWriter().encode(content,
				BarcodeFormat.CODE_128, 380, 100);
		int width = matrix.getWidth();
		int height = matrix.getHeight();
		int[] pixels = new int[width * height];
		for (int y = 0; y < height; y++) {
			for (int x = 0; x < width; x++) {
				if (matrix.get(x, y)) {
					pixels[y * width + x] = 0xff000000;
				}
			}
		}

		Bitmap bitmap = Bitmap.createBitmap(width, height,
				Bitmap.Config.ARGB_8888);
		// 通过像素数组生成bitmap
		bitmap.setPixels(pixels, 0, width, 0, 0, width, height);
		return bitmap;
	}



}
